.const 
IFNDEF ZEROLOCALES
	ZEROLOCALES MACRO 
		mov eax, esp
		mov esp, ebp	; base page of calling procedure
		@@:
		push 0
		cmp esp, eax
		ja @B	
	ENDM	
ENDIF
IFNDEF FICHMEM	
FICHMEM STRUCT
	Hmem     dd ?
	Mpoint   dd ?
	MemSize  dd ?
	Taille   dd ?
FICHMEM ENDS
ENDIF	

OuvrirLecture PROTO :DWORD
write_obj PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD	
SetTestFichier PROTO :DWORD
OuvrirEcriture PROTO :DWORD
ChargerFichierMem PROTO :DWORD,:DWORD
SetTestFichier PROTO :DWORD
TestFichier PROTO :DWORD

.data
 hRslt3    dd 0
 hRslt4    dd 0
 badaligntitre    db "Bad Alignment",0	
 badalignMessage db "IMAGE_FILE_HEADER IMAGE_SECTION_HEADER IMAGE_SYMBOL",13,10
			db "need to be not aligned,remove Zpn option of ml",0
;------------------------------------------------------------------------
;----------- disk input output ----------------------
	ercharge db "Taille ",0
	texthou db " Handle fichier ",0
	textHmem db "Handle memoire ",0
	textPm db "Pointeur memoire ",0
	textlu db " Nb octets en lecture ",0	
	NomComplet db MAX_PATH dup (0)
 	FicErreur db " le fichier n'existe pas (SetTestFichier) ! ",0
      barre db "\",0
	InfosFichiers WIN32_FIND_DATA	<>
	extobj db ".obj",0
	extinclude db ".inc",0
.code
;################################################################

; 
;paln adresse chaine align db "4",0
;pinput adresse en mmoire du fichier d'entre 
;sizeinput taille mmoire occupe par le fichier d'entre
;poutput adresse du fichier de sortie 
;pinclude adresse du fichier  inclure 
;pname pointeur sur le _nom du label nomlabel= "_" + NomLabel 
write_obj proc uses ebx pinput:DWORD,sizeinput:DWORD,poutput:DWORD,pinclude:DWORD,pname:DWORD,paln:DWORD
	LOCAL filler [128]  :BYTE 
	LOCAL hout          :DWORD              ; output file handle
	LOCAL wcnt          :DWORD
	LOCAL hinc          :DWORD              ; file handle for output include file
	LOCAL aflag         :DWORD              ; alignment flag
	LOCAL alind         :DWORD              ; variable to hold alignment choice
	LOCAL buffer2[260]  :BYTE               ; target file name buffer
	LOCAL ifh     	  :IMAGE_FILE_HEADER 
	LOCAL ish     	  :IMAGE_SECTION_HEADER 
	LOCAL ist     	  :IMAGE_SYMBOL	
	Local BytesWritten  :DWORD
	ZEROLOCALES 
	mov ebx,0	;compteur du fichier objet	
	;-------in case of Rebuild of source code,verify that structures are not bad aligned 
    	mov eax,SIZEOF IMAGE_FILE_HEADER + SIZEOF IMAGE_SECTION_HEADER + SIZEOF IMAGE_SYMBOL
	.if eax != 4Eh		
		invoke MessageBox,NULL,ADDR badalignMessage,addr badaligntitre,MB_OK
		jmp Findewrite_obj
	.endif
	
; ********************
; load alignment values
; ********************
	call image_align                        ; call procedure to set alignment flag
	;aflag alind
	mov hout, fcreate(poutput)

; ----------------------------------------------
; calculate the start offset of the symbol table
; ----------------------------------------------
	mov edx, SIZEOF IMAGE_FILE_HEADER
	add edx, SIZEOF IMAGE_SECTION_HEADER
	add edx, sizeinput

; -----------------
; IMAGE_FILE_HEADER
; -----------------
	mov ifh.Machine,                IMAGE_FILE_MACHINE_I386         ; dw
	mov ifh.NumberOfSections,       1                               ; dw
	mov ifh.PointerToSymbolTable,   edx                             ; dd
	mov ifh.NumberOfSymbols,        1                               ; dd
	mov ifh.Characteristics,        IMAGE_FILE_RELOCS_STRIPPED or \
					IMAGE_FILE_LINE_NUMS_STRIPPED   ; dw
; --------------------
; IMAGE_SECTION_HEADER
; --------------------
	lea eax, ish.Name1
	mov DWORD PTR [eax], "tad."     ; write ".data" to Name1 member
	mov DWORD PTR [eax+4], "a"
	m2m ish.SizeOfRawData,          sizeinput        ; dd

	mov edx, SIZEOF IMAGE_FILE_HEADER
	add edx, SIZEOF IMAGE_SECTION_HEADER
	mov ish.PointerToRawData,       edx         ; dd

	mov eax, IMAGE_SCN_CNT_INITIALIZED_DATA or IMAGE_SCN_MEM_READ or IMAGE_SCN_MEM_WRITE
	or eax, aflag
	mov ish.Characteristics, eax                ; dd

; -----------------
; COFF SYMBOL TABLE
; -----------------
	lea eax, ist.N.LongName
	mov DWORD PTR [eax+4], 4                    ; OFFSET is 4th byte into the string table

	mov ist.SectionNumber, 1
	mov ist.StorageClass, IMAGE_SYM_CLASS_EXTERNAL

; --------------------
; write result to file
; --------------------
      invoke WriteFile,hout,ADDR ifh,SIZEOF IMAGE_FILE_HEADER,ADDR BytesWritten,NULL
	mov ebx,BytesWritten
	invoke WriteFile,hout,ADDR ish,SIZEOF IMAGE_SECTION_HEADER,ADDR BytesWritten,NULL
	add ebx,BytesWritten
	invoke WriteFile,hout,pinput,sizeinput,ADDR BytesWritten,NULL
	add ebx,BytesWritten	
	invoke WriteFile,hout,ADDR ist,SIZEOF IMAGE_SYMBOL,ADDR BytesWritten,NULL
	add ebx,BytesWritten	
	;(4E  78) + (590 24E)
; ------------
; string table
; ------------
	mov wcnt, 64 ; write the table length to 1st DWORD
	invoke WriteFile,hout,ADDR wcnt,4,ADDR BytesWritten,NULL
	add ebx,BytesWritten		

	mov edx, len(pname); write the data label name after it.
	invoke WriteFile,hout,pname,edx,ADDR BytesWritten,NULL
	add ebx,BytesWritten		

	mov edx, len(pname)                         ; length of name
	add edx, 4                                  ; add 4 for 1st DWORD
	mov wcnt, 65
	sub wcnt, edx
	invoke WriteFile,hout,ADDR filler,wcnt,ADDR BytesWritten,NULL
	add ebx,BytesWritten
	
	fclose hout		;close outputfile
			;data file closed by user

; ---------------------------------
; write the EXTERNDEF statement and
; length equate to the include file
; ---------------------------------

	mov hinc, fcreate(pinclude)

	fprint hinc,"; -----------------------------------------------------"
	fprint hinc,"; Include the contents of this file in your source file"
	fprint hinc,"; to access the data as an OFFSET and use the equate as"
	fprint hinc,"; the byte count for the file data in the object module"
	fprint hinc,"; -----------------------------------------------------"

	mov edx, len(pname)
	sub edx, 1
	mov pname, right$(pname,edx)

	mov poutput, ptr$(buffer2)
	mov poutput, cat$(poutput,"EXTERNDEF ",pname,":DWORD")
	fprint hinc,poutput

	mov poutput, ptr$(buffer2)
	mov poutput, cat$(poutput,"ln_",pname," equ ",chr$(60),str$(sizeinput),chr$(62))
	fprint hinc, poutput

	fclose hinc


; -----------------------------------------
Findewrite_obj:
	mov eax,ebx
	ret
OutDisk:
retn	
;-----------------------------------------------	
image_align:  	
	invoke atodw,paln
	mov alind, eax	
	.if eax == 1
		mov eax,IMAGE_SCN_ALIGN_1BYTES		
	.elseif eax == 2
		mov eax, IMAGE_SCN_ALIGN_2BYTES ; 2
	.elseif eax == 4	
		mov eax, IMAGE_SCN_ALIGN_4BYTES ; 4
	.elseif eax == 8		
		mov eax, IMAGE_SCN_ALIGN_8BYTES ; 8
	.elseif eax == 16		
		mov eax, IMAGE_SCN_ALIGN_16BYTES ; 16
	.elseif eax == 32		
		mov eax, IMAGE_SCN_ALIGN_32BYTES ; 32
	.elseif eax == 64		
		mov eax, IMAGE_SCN_ALIGN_64BYTES ; 64
	.elseif eax == 128		
		mov eax, IMAGE_SCN_ALIGN_128BYTES ; 128
	.elseif eax == 256		
		mov eax, IMAGE_SCN_ALIGN_256BYTES ; 256
	.elseif eax == 512		
		mov eax, IMAGE_SCN_ALIGN_512BYTES ; 512
	.elseif eax == 1024	
		mov eax, IMAGE_SCN_ALIGN_1024BYTES ; 1024
	.elseif eax == 2048
		mov eax, IMAGE_SCN_ALIGN_2048BYTES ; 2048
	.elseif eax == 4096		
		mov eax, IMAGE_SCN_ALIGN_4096BYTES ; 4096
	.elseif eax == 8192		
		mov eax, IMAGE_SCN_ALIGN_8192BYTES ; 8192
	.else
		xor eax, eax ;pas trouv
	.endif
	mov aflag, eax	
	retn
	
write_obj endp



;################################################################

 ChargerFichierMem proc uses esi edi ebx NomAediter:DWORD,pfichmem:DWORD
		LOCAL retour:DWORD
		LOCAL fichier:DWORD
		local hMemory:DWORD
		local pMemory:DWORD
		local hFile:DWORD
		local NbOctetsaLire:DWORD
		local NbOctetsLus:DWORD

          ;pfichmem adresse d'une structure FICHMEM
	   ;rajoute un zero en fin de fichier
	   ;ncessaire dans les copies avec clipboard par exemple
	   ;utilise  WIN32_FIND_DATA et NomComplet
	invoke SetTestFichier,NomAediter	   	
	.if eax==FALSE        
		mov retour,0
		jmp FindeChargerFichierMem
	.else
		mov fichier,eax
	.endif	
	mov ebx,pfichmem 

	;----------------------------
	;  ouvrir le fichier
	;----------------------------
	invoke OuvrirLecture,fichier
	.if eax==INVALID_HANDLE_VALUE
		;invoke  MessageBox,NULL,SADD(" Erreur d'ouverture Fichier "),\
		;			SADD("ChargerFichierMem"),MB_OK
		mov retour,0
		jmp FindeChargerFichierMem
	.endif 
	mov hFile,eax 

	;-------------------------
	;obtenir le handle de mmoire, taille du fichier dw 
	;-------------------------
	mov ecx,InfosFichiers.nFileSizeLow
	mov dword ptr (FICHMEM ptr [ebx]).Taille,ecx
	inc ecx			;pour rajouter le zero en fin de fichier
	add ecx,16		;au moins 1 zero,au plus 16
	and ecx,0FFFFFFF0h	;rounded 16 bytes upper
	mov dword ptr [ebx].FICHMEM.MemSize,ecx
	invoke GlobalAlloc,GMEM_MOVEABLE or GMEM_ZEROINIT,ecx
					
	.if eax == 0
		;invoke  MessageBox,NULL,SADD("Pas assez de place mmoire "),\
		;			SADD("GlobalAlloc"),MB_OK
		mov retour,0
		jmp FindeChargerFichierMem
	.endif            
	mov  hMemory,eax
	mov dword ptr [ebx].FICHMEM.Hmem,eax
	;obtenir le pointeur de memoire
	invoke GlobalLock,hMemory
	mov  pMemory,eax
	mov dword ptr [ebx].FICHMEM.Mpoint,eax

	mov eax,InfosFichiers.nFileSizeLow  
	mov NbOctetsaLire,eax
	invoke ReadFile,hFile,pMemory,NbOctetsaLire,addr NbOctetsLus,NULL
			
	;-------------------------
	;libr la memoire ,ferm le fichier ouvert
	;-------------------------
		; invoke GlobalUnlock,pMemory
		; invoke GlobalFree,hMemory
	invoke CloseHandle,hFile
		mov retour,1
FindeChargerFichierMem:
		mov eax,retour
		ret
ChargerFichierMem endp

;#########################################################################

OuvrirLecture proc NomaOuvrir:Dword
           invoke CreateFile,NomaOuvrir,\
                        GENERIC_READ,NULL,\
                        NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
          .if eax==INVALID_HANDLE_VALUE
		push eax
          ;invoke  MessageBox,NULL,SADD("erreur ouverture fichier "),\
          ;            SADD("OuvrirLecture"),MB_OK
		pop eax
          .endif
            
             ret
OuvrirLecture endp

; #########################################################################
OuvrirEcriture proc NomaOuvrir:Dword
           invoke CreateFile,NomaOuvrir,\
                        GENERIC_WRITE,NULL,\
                        NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
          .if eax==INVALID_HANDLE_VALUE
			push eax
			;invoke  MessageBox,NULL,SADD("erreur ouverture fichier "),SADD("OuvrirEcriture"),MB_OK
			pop eax
	   .endif
            
             ret
OuvrirEcriture endp

; #########################################################################
 SetTestFichier proc  NomaTester:DWORD
		;rcrit le nom complet valide dans NomComplet
		;chec retourne zro , russite adresse de NomComplet
          local HSearch:DWORD
	   local retour:DWORD
	   pushad
          invoke RtlZeroMemory,addr InfosFichiers,sizeof InfosFichiers
           ;recomposer le chemin complet si necessaire
          invoke GetCurrentDirectory,sizeof NomComplet,addr NomComplet

          invoke lnstr,NomaTester
          mov ecx,eax
          mov al,"\"
          mov edi,NomaTester
          add edi,ecx
          std
          repne scasb
          cld
            .if ecx==0
                 ; nom sans chemin
                 invoke szCatStr,addr NomComplet,addr barre 
                 invoke szCatStr,addr NomComplet,NomaTester
           .else
                 ;recopier le nom complet dans NomComplet
                 invoke lnstr,NomaTester
                 mov ecx,eax
                 ;ajoute le zero
                 mov esi , NomaTester
                 lea edi,NomComplet
		    cld	
                 rep movsb
		    mov al,0
		   stosb	  	
          .endif
          
          ;----------------------------------------------------------------
          ;non obligatoire mais tellement utile pour connaitre le fichier !
          ;----------------------------------------------------------------
          invoke FindFirstFile,addr NomComplet,addr InfosFichiers
 		
          ;----------------------------------------------------------
          ; taille du fichier nFileSizeHigh; DWORD    nFileSizeLow WIN32_FIND_DATA
          ;   nom court ou nom long sans chemin ?         
          ;-----------------------------------------------------------
          
          .if eax==INVALID_HANDLE_VALUE		 
		;InsTxt MsgERRSetTestFichier, "SetTestFichier"		; Nom de la fonction ayant echou
		;invoke RetrouveMessageErreur, ADDR MsgERRSetTestFichier	; la boite de message
               mov retour,0          
               jmp FindeSetTestFichier
          .endif
          mov HSearch,eax
          ; fermer la recherche
          invoke FindClose,HSearch
         lea eax,NomComplet
         mov retour,eax
         ;------------------------------------------------------         
         ; on connait maintenant toutes les infos sur le fichier          
         ;-------------------------------------------------------
         
 FindeSetTestFichier:  
	  popad
	  mov eax,retour	                 
         ret             
SetTestFichier endp
; #########################################################################

; #########################################################################
 TestFichier proc  NomaTester:DWORD
		;rcrit le nom complet valide dans NomComplet
		;chec retourne zro , russite adresse de NomComplet
	   local retour:DWORD
	   pushad
          invoke RtlZeroMemory,addr InfosFichiers,sizeof InfosFichiers
          invoke FindFirstFile,NomaTester,addr InfosFichiers
 		
          ;----------------------------------------------------------
          ; taille du fichier nFileSizeHigh; DWORD    nFileSizeLow WIN32_FIND_DATA
          ;   nom court ou nom long sans chemin ?         
          ;-----------------------------------------------------------
          
          .if eax==INVALID_HANDLE_VALUE		 
               mov retour,0          
	   .else
	   	mov edx,eax
          	invoke FindClose,edx
               mov retour,1	   		
          .endif
         ;------------------------------------------------------         
         ; on connait maintenant toutes les infos sur le fichier          
         ;-------------------------------------------------------
         
 FindeTestFichier:  
	  popad
	  mov eax,retour	                 
         ret             
TestFichier endp

